/****************************************************************************
**
** Copyright (C) 1992-2009 Nokia. All rights reserved.
**
** This file is part of Qt Jambi.
**
** ** No Commercial Usage
** This file contains pre-release code and may not be distributed.
** You may use this file in accordance with the terms and conditions
** contained in the either Technology Preview License Agreement or the
** Beta Release License Agreement.
**
** If you are unsure which license is appropriate for your use, please
** contact the sales department at qt-sales@nokia.com.


**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef QTJAMBI_DEBUG_TOOLS_H
#define QTJAMBI_DEBUG_TOOLS_H

#if defined(QTJAMBI_DEBUG_TOOLS)

#include "qtjambi_global.h"

#define QTJAMBI_COUNTER_DECLARATIONS(NAME) \
    void QTJAMBI_EXPORT qtjambi_increase_##NAME(const QString &className)

    QTJAMBI_COUNTER_DECLARATIONS(finalizedCount);
    QTJAMBI_COUNTER_DECLARATIONS(userDataDestroyedCount);
    QTJAMBI_COUNTER_DECLARATIONS(destructorFunctionCalledCount);
    QTJAMBI_COUNTER_DECLARATIONS(shellDestructorCalledCount);
    QTJAMBI_COUNTER_DECLARATIONS(objectInvalidatedCount);
    QTJAMBI_COUNTER_DECLARATIONS(disposeCalledCount);
    QTJAMBI_COUNTER_DECLARATIONS(linkDestroyedCount);
    QTJAMBI_COUNTER_DECLARATIONS(linkConstructedCount);

#else
#  error Don't include this file without QTJAMBI_DEBUG_TOOLS defined
#endif

#endif
